/******************************************************************************
;  *   	@MCU				 : MC51F003A4
;  *   	@Create Date         : 2020.01.02
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQȺ   : 814641858
;  *    @΢ٷ̳       : http://bbs.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *			         SPI⣬úʹã²Ҫ޸                            		
******************************************************************************/

#include "SPI_LIB.h"

/************************************************
;  *    @Function Name       : SPI_Init
;  *    @Description         : 
;  *    @IN_Parameter      	 :  SPI ò
;  *    @Return parameter    :
;  ***********************************************/
void SPI_Init(SPI_InitTypeDef *SPI)
{
    SPCON = REG_CLR;
    SPSTA = REG_CLR;
    SPDAT = REG_CLR;

    SPCON |= SPI->SPI_NSS;
    SPCON |= SPI->SPI_first_bit | SPI->SPI_mode | SPI->SPI_CPHA | SPI->SPI_CPOL | SPI->SPI_clock_division;
    if (SPI->SPI_interrupt == ENABLE) //ʹSPIж
    {
        IP &= ~SPI_IE_ADDR;
        IPH &= ~SPI_IE_ADDR; //жȼ
        SPIIE = ENABLE;
        if (SPI->SPI_interrupt_priority == HIGH)
        {
            IP |= SPI_IE_ADDR; //жȼ
        }
    }
    else
    {
        SPIIE = DISABLE;
        IP &= ~SPI_IE_ADDR;
        IPH &= ~SPI_IE_ADDR; //жȼ
    }
}
/************************************************
;  *    @Function Name       : SPI_Cmd
;  *    @Description         : SPIEN˿
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void SPI_Cmd(uint8_t newstate)
{
    if (newstate == ENABLE)
        SPSTA |= SPI_EN;
    else
        SPSTA &= ~SPI_EN;
}

/************************************************
;  *    @Function Name       : SPI_Get_FlagStatus
;  *    @Description         : ȡ״̬
;  *    @IN_Parameter        :  SPI_FLAG_DATA_COMPLETION ݴ
                                SPI_FLAG_MODE_FAOLURE    ģʽ
                                SPI_FLAG_WRITE_CONFLICT  дͻ
                                SPI_FLAG_RECEIV_OVERRUN  ճ
;  *    @Return parameter    :
;  ***********************************************/
flagstatus SPI_Get_FlagStatus(uint8_t SPI_flag)
{
    flagstatus bitstatus = RESET;
    if ((SPSTA & SPI_flag) != (uint8_t)RESET)
    {
        bitstatus = SET;
    }
    else
    {
        bitstatus = RESET;
    }
    return bitstatus;
}
/************************************************
;  *    @Function Name       : SPI_Clear_FlagStatus
;  *    @Description         : ״̬
;  *    @IN_Parameter        :  SPI_FLAG_DATA_COMPLETION ݴ
                                SPI_FLAG_MODE_FAOLURE    ģʽ
                                SPI_FLAG_WRITE_CONFLICT  дͻ
                                SPI_FLAG_RECEIV_OVERRUN  ճ
;  *    @Return parameter    :
;  ***********************************************/
void SPI_Clear_FlagStatus(uint8_t SPI_flag)
{
    SPSTA &= ~SPI_flag;
}
/************************************************
;  *    @Function Name       : SPI_Receive_Data
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
uint8_t SPI_Receive_Data(void)
{
    return SPDAT;
}
/************************************************
;  *    @Function Name       : SPI_Send_Data
;  *    @Description         : 
;  *    @IN_Parameter        :
;  *    @Return parameter    :
;  ***********************************************/
void SPI_Send_Data(uint8_t dat)
{
    SPDAT = dat;
}

/**************************** end of file *********************************************/
