/******************************************************************************
;  *   	@MCU				 : MC51F003A4
;  *   	@Create Date         : 2021.10.11
;  *   	@Author/Corporation  : Martin/SinoMCU
;  *   	@΢֧QQ 	 : 2048615934
;  *    @΢		     : http://www.sinomcu.com/
;  *   	@Copyright           : 2020 SINOMCU Corporation,All Rights Reserved.
;  *----------------------Abstract Description---------------------------------
;  *			                                        		
******************************************************************************/
#include "PWM.h"

/************************************************
;  *    @Function Name       : PWM1_Init
;  *    @Description         : PWM1
;  *    @IN_Parameter      	 :
;  *    @Return parameter    :
;  ***********************************************/
void PWM1_Init(void)
{

	SLK_SFR1();				  //лSFR1
	PWM1CR1 &= ~DEF_SET_BIT7; //PWM1ʱFSYS
	//PWM1 ,޸Ƶ,Ӱ PWM1 ;
	//鰴ΪȹرPWM1,޸ĺٴPWM1˳
	PWM1CR1 &= 0xf8;
	PWM1CR1 |= 0x04;																					  //PWM1CLK=16Ƶ
	PWM1IER |= DEF_SET_BIT0;																			  //ʹɲ
	PWM1IER |= DEF_SET_BIT1;																			  //½	P2.6
	PWM1CR0 |= (DEF_SET_BIT0 | DEF_SET_BIT1 | DEF_SET_BIT2 | DEF_SET_BIT3 | DEF_SET_BIT4 | DEF_SET_BIT5); //6ͨʹ
	PWM1PH = 1000 >> 8;
	PWM1PL = 1000 % 256;																				  //
	PWM1CR2 |= DEF_SET_BIT7;																			  //Զ
	PWM1CR2 &= ~(DEF_SET_BIT0 | DEF_SET_BIT1 | DEF_SET_BIT2);											  //ռձ ߵƽ
	PWM1CR3 |= (DEF_SET_BIT0 | DEF_SET_BIT1 | DEF_SET_BIT2 | DEF_SET_BIT3 | DEF_SET_BIT4 | DEF_SET_BIT5); //6ͨȽʹ
	PWM1CR3 |= DEF_SET_BIT7;																			  //Ƚʹ

#if (PWM1_Mode == 1)										  //ģʽ
	PWM1CR1 &= ~(DEF_SET_BIT4 | DEF_SET_BIT5 | DEF_SET_BIT6); //ģʽ
	PWM1CR2 |= (DEF_SET_BIT4 | DEF_SET_BIT5 | DEF_SET_BIT6);  //ʱʹ
	PWM10DH = 600 >> 8;
	PWM10DL = 600 % 256; //ռձ60%
	PWM101F = 30;		 //ʱ	PWM101F/FSYS/PWM1CLK=30/16M/16=30us
	PWM12DH = 500 >> 8;
	PWM12DL = 500 % 256; //ռձ50%
	PWM123F = 20;		 //ʱ	20us
	PWM14DH = 400 >> 8;
	PWM14DL = 400 % 256; //ռձ40%
	PWM145F = 10;		 //ʱ	10us
#endif
#if (PWM1_Mode == 2)										 //ģʽ
	PWM1CR1 |= (DEF_SET_BIT4 | DEF_SET_BIT5 | DEF_SET_BIT6); //ģʽ
	PWM10DH = 1000 >> 8;
	PWM10DL = 1000 % 256; //ռձ100%
	PWM11DH = 800 >> 8;
	PWM11DL = 800 % 256; //ռձ80%
	PWM12DH = 600 >> 8;
	PWM12DL = 600 % 256; //ռձ60%
	PWM13DH = 400 >> 8;
	PWM13DL = 400 % 256; //ռձ40%
	PWM14DH = 200 >> 8;
	PWM14DL = 200 % 256; //ռձ20%
	PWM15DH = 0 >> 8;
	PWM15DL = 0 % 256; //ռձ0%
#endif
  PWM1CR0 |= DEF_SET_BIT7;  //ʹPWM1
	
	SLK_SFR0();							  //лSFR0
	IE1 |= (DEF_SET_BIT2 | DEF_SET_BIT5); //ʹɲжϸѡ
}

void PWM1_ISR(void) interrupt PWM1_IRQn //ж
{
	SFR_INTERRUPT_BUFF_BIT_PWM1 = SFRSL0;		//жϻSFR
	
	SLK_SFR1();		//л1ҳĴ
	PWM1IER &= ~DEF_SET_BIT7; //жϱ־
	SLK_SFR0();		//л0ҳĴ
	LED1 = !LED1; // IOת
	
	SFRSL0 = SFR_INTERRUPT_BUFF_BIT_PWM1;		//˳жϻԭSFR
	
}
void PWM1_FB_ISR(void) interrupt PWM1_FB_IRQn //ɲж
{
	SFR_INTERRUPT_BUFF_BIT_PWM1_FB = SFRSL0;		//жϻSFR
	
	SLK_SFR0(); //лSFR0
	if (KEY1 == 0) //ɲ
	{
		SLK_SFR1();		//л1ҳĴ
		PWM1IER &= ~DEF_SET_BIT6; //жϱ־
		SLK_SFR0();		//л0ҳĴ
		LED2 = 0;
	}
	else
	{
		LED2 = !LED2;
	}
	
	SFRSL0 = SFR_INTERRUPT_BUFF_BIT_PWM1_FB;		//˳жϻԭSFR
}

/**************************** end of file *********************************************/
